#region usings
using System;
using System.ComponentModel.Composition;
using System.Windows.Forms;
using System.Drawing;
using System.Runtime.InteropServices;
using Microsoft.VisualStudio.OLE.Interop;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;

using VVVV.Core.Logging;
#endregion usings

namespace VVVV.Nodes
{
	#region PluginInfo
	[PluginInfo(Name = "MyWindow", Category = "Value", Help = "Basic template with one value in/out", Tags = "")]
	#endregion PluginInfo
	public class ValueMyWindowNode : IPluginEvaluate, IWin32Window, ICustomQueryInterface
	{
		#region fields & pins
		[Input("Input", DefaultValue = 1.0)]
		public ISpread<double> FInput;

		[Output("Output")]
		public ISpread<double> FOutput;
		
		UserControl FMyForm = new UserControl();

		[Import()]
		public ILogger FLogger;
		#endregion fields & pins

		//called when data for any output pin is requested
		public void Evaluate(int SpreadMax)
		{
			FMyForm.Size = new Size(100, 100);
			FOutput.SliceCount = SpreadMax;

			for (int i = 0; i < SpreadMax; i++)
				FOutput[i] = FInput[i] * 2;

			//FLogger.Log(LogType.Debug, "hi tty!");
		}
		
		public IntPtr Handle
		{
		   get {return FMyForm.Handle;}
		}
		
		public CustomQueryInterfaceResult GetInterface(ref Guid iid, out IntPtr ppv)
{
   if (iid.Equals(Guid.Parse("00000112-0000-0000-c000-000000000046")))
   {
      ppv = Marshal.GetComInterfaceForObject(FMyForm, typeof(IOleObject));
      return CustomQueryInterfaceResult.Handled;
   }
   else if (iid.Equals(Guid.Parse("458AB8A2-A1EA-4d7b-8EBE-DEE5D3D9442C")))
   {
      ppv = Marshal.GetComInterfaceForObject(FMyForm, typeof(IWin32Window));
      return CustomQueryInterfaceResult.Handled;
   }
   else
   {
      FLogger.Log(LogType.Debug, "missing: " + iid.ToString());
      ppv = IntPtr.Zero;
      return CustomQueryInterfaceResult.NotHandled;
   }
}
	}
}
